#include <iostream>
#include <winsock.h>
#include <process.h>
#include "CSocket.h"
#include "CClient.h"
using namespace std;
///////////////////////////////////////////////////////////////////
//	CClient.cpp                                                    //
//                                                               //
//  ver 1.0                                                      //
//                                                               //
//  Language:        Visual C, ver 6.0                           //
//  Platform:        Micron Dual Pentium Pro 200, Win NT 4.0     //
//  Application:     CSE691 Project #2                           //
//  Author:         Jianxiang Jin            CSE691, Fall '99    //
//                   Syracuse University       (315) 443-1053    //
//                   jjin@syr.edu                                //
//                                                               //
///////////////////////////////////////////////////////////////////


//----< make socket connection >-------------------------------

bool CClient::connectToServer( const std::string &address, int port) {

  struct sockaddr_in Address;
  Address.sin_family = AF_INET;
  Address.sin_addr.s_addr = inet_addr(address.c_str());
  Address.sin_port = htons(port);
  if(connect(sock, (sockaddr*)&Address, sizeof(Address)) == SOCKET_ERROR) {
    errorOut("can't connect to server",false);
    return false;
  }
  return true;
}



//----< process file messages >--------------------------------
//
//  - convert file_data messages into files 
//   client side
bool processMsg(CMessage rMsg) {
	
  DWORD bytesWritten;
  string fileName = ".\\cData\\";
  rMsg.setBlockElement(rMsg.getLength(),'\0');
  fileName += rMsg.getBlockArray();

  HANDLE hFile = ::CreateFile(
    fileName.c_str(),GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
    FILE_ATTRIBUTE_NORMAL,NULL
  );
  if(hFile == INVALID_HANDLE_VALUE) {
    safeOut("\n--- can't open file for writing ---\n");
    return false;
  }
  string temp = "\n  -- storing file ";
  temp += rMsg.getBlockArray();
  temp += " --";
  safeOut(temp.c_str());
  long int sumBytes = 0;
  do {
    while(inQ.length() == 0){
//safeOut("--------------------------processMsg here--------------------------------\n");
      Sleep(50);
		}
    inQ.deQ(rMsg);
    if(rMsg.getMsgType() == file_data) {
      if(!::WriteFile(hFile,rMsg.getBlockArray(),rMsg.getLength(),&bytesWritten,NULL)) {
        safeOut("\n  --- error writing file ---\n");
        CloseHandle(hFile);
        return false;
      }
      else
        sumBytes += bytesWritten;
    }
  } while(rMsg.getMsgType() != end_file);
  trace("  --- wrote ",sumBytes," bytes ---\n");
  CloseHandle(hFile);
//safeOut("------------end--------------processMsg--------------------------------\n");
  return true;
}

//

//--< msgClnt's worker thread >--------------------------------
//
//  - deQs file_data msgs and passes them on to processMsg(...)
//    function
//  - only quits when it receives a reflected done CMessage, e.g., 
//    a CMessage originally sent by this client
//
void _cdecl clientWorker(void*) {

  CMessage rMsg;

  while(1) {

    while(inQ.length() == 0)
      Sleep(50);

    inQ.deQ(rMsg);
    if(rMsg.getMsgType() == done)
      break;

    if(rMsg.getMsgType() == send_file)
      processMsg(rMsg);
  }
}



//----< entry point >------------------------------------------

void main(int argc, char *argv[]) {
  try {  
	cout << "\n ----------------------------------------\n";	cout << "\n             Welcome ! \n";	cout << "\n          Server is started\n"	;		cout << "\n         Jianxiang Jin    jjin@syr.edu  		\n";	cout << "\n ----------------------------------------\n";  		cout << "\n ==================================="<< "\n  messenger client requesting files "<< "\n ===================================\n";
	initializeSockets();  initializeUtils();
	CClient c;
  CMessage sMsg, rMsg;
  char block[BlockSize];
  if(argc == 1) { cout << "\n  please supply an IP address as a command line argument\n"<< "\n  use 127.0.0.1 to specify the client machine\n\n";    return;  }
  c.createSocket();//conenct to server
  if(!c.connectToServer(argv[1],1024)) {
    safeOut("\n  --- can't connect to server ---");    c.closeSocket();    return;
  }
  int numBytes, numSets = 20,i,count=0;
  for(i=0; i<numSets; i++) {
    sMsg = sMsg.buildMsg(0,send_file,0,block);    sMsg.stringToMsgBlock(sMsg,"CSocket.cpp");  
		sMsg.showMsg("sending to server");    numBytes =c.sendMsg(sMsg);
    sMsg = sMsg.buildMsg(0,send_file,0,block);    sMsg.stringToMsgBlock(sMsg,"CSocket.h");    
		sMsg.showMsg("sending to server");    numBytes = c.sendMsg(sMsg);
  }
  sMsg = sMsg.buildMsg(0,done,0,block);  sMsg.showMsg("sending to server");
  numBytes = c.sendMsg(sMsg);
  HANDLE thWorker = (HANDLE)_beginthread(clientWorker,0,(void*)NULL);
  if(thWorker == INVALID_HANDLE_VALUE) {
    MessageBox(     NULL,"could not start thread to collect files","debugging",MB_OK   );
    c.closeSocket();    return;
  }
  while(1) {
    numBytes = c.recvMsg(rMsg);
    inQ.enQ(rMsg);
    if(rMsg.getMsgType() == done)   break;   
  }
  WaitForSingleObject(thWorker,INFINITE);
  sMsg = sMsg.buildMsg(0,disconnect,0,block);
  sMsg.showMsg("sending to server");
  numBytes = c.sendMsg(sMsg);	
	CClient sd;
	sd.createSocket();
  if(!sd.connectToServer(argv[1],1024)) {    safeOut("\n  --- can't connect to server ---");
    return;  }  
  Sleep(100);  sMsg = sMsg.buildMsg(1,shutDownServer,0,block);
  sMsg.showMsg("sending to server");  numBytes = sd.sendMsg(sMsg);
  c.closeSocket();  sd.closeSocket();
  cleanUpSockets();  cleanUpUtils();
  cout << "\n" << endl;
  } catch(...) { safeOut("\n --- exception thrown in msgclnt ---\n"); }
}



