#ifndef CCLIENT_H
#define CCLIENT_H
#include "CSocket.h"
///////////////////////////////////////////////////////////////////
//	CClient.h                                                    //
//                                                               //
//  ver 1.0                                                      //
//                                                               //
//  Language:        Visual C, ver 6.0                           //
//  Platform:        Micron Dual Pentium Pro 200, Win NT 4.0     //
//  Application:     CSE691 Project #2                           //
//  Author:         Jianxiang Jin            CSE691, Fall '99    //
//                   Syracuse University       (315) 443-1053    //
//                   jjin@syr.edu                                //
//                                                               //
///////////////////////////////////////////////////////////////////
/*

    Module Operations
    =================
		Define the basic operations for socket and CMessage handling.

    Public Interface
    ================

		bool connectToServer( const std::string &address, int port);
		-------connect to server;
*/

//
///////////////////////////////////////////////////////////////
//  build process                                            //
///////////////////////////////////////////////////////////////
//  required files:                                          //
//    Win32utils.h, Win32utils.cpp													 //
//    CMessage.h CMessage.cpp																 //
//		mtqueue.h  mtqueue.cpp																 //		
//		CSocket.h   CSocket.cpp																 //
//		CClient.h   CClient.cpp																 //	
//                                                           //
//  compiler command line invocation:                        //
//    cl -GX -DTEST_CSocket   CSocket.cpp                    // 
//		CMessage.cpp mtqueue.cpp Win32utils.cpp		CSocket.cpp	 //
///////////////////////////////////////////////////////////////
/*
    Maintenance History
    ===================
    ver 1.0 

*/



bool processMsg(CMessage rMsg);
class CClient:public CSocket{
public:	
	bool connectToServer( const std::string &address, int port);

};
//----< global queue used to queue up file_data msgs >---------
mtqueue<CMessage> inQ;

#endif	