#ifndef CSERVER_H
#define	CSERVER_H
#include "CSocket.h"
///////////////////////////////////////////////////////////////////
//	CServer.h                                                    //
//                                                               //
//  ver 1.0                                                      //
//                                                               //
//  Language:        Visual C, ver 6.0                           //
//  Platform:        Micron Dual Pentium Pro 200, Win NT 4.0     //
//  Application:     CSE691 Project #2                           //
//  Author:         Jianxiang Jin            CSE691, Fall '99    //
//                   Syracuse University       (315) 443-1053    //
//                   jjin@syr.edu                                //
//                                                               //
///////////////////////////////////////////////////////////////////
/*

    Module Operations
    =================
		Define the basic operations for socket and CMessage handling.

    Public Interface
    ================		
		void startServer( int port);
		-----------start server
		
		void	processFileMessages(CMessage &rMsg,mtqueue<CMessage> &out);
		-----------send file to client

*/

//
///////////////////////////////////////////////////////////////
//  build process                                            //
///////////////////////////////////////////////////////////////
//  required files:                                          //
//    Win32utils.h, Win32utils.cpp													 //
//    CMessage.h CMessage.cpp																 //
//		mtqueue.h  mtqueue.cpp																 //		
//		CSocket.h   CSocket.cpp																 //
//		CServer.h   CServer.cpp																 //	
//                                                           //
//  compiler command line invocation:                        //
//    cl -GX -DTEST_CSocket   CSocket.cpp                    // 
//		CMessage.cpp mtqueue.cpp Win32utils.cpp		CSocket.cpp	 //
///////////////////////////////////////////////////////////////
/*
    Maintenance History
    ===================
    ver 1.0 

*/


class CServer:public CSocket{
public:
	//start server
	void startServer( int port);
	//send file to client
	void	processFileMessages(CMessage &rMsg,mtqueue<CMessage> &out);
};

//----< communicating queue >----------------------------------
//
//  structure used to pass socket pointer
//  and queue pointer to a thread function
//
//struct comQ { SOCKET sock; mtqueue<CMessage> *pQ; };
struct comQ { CServer newClient; mtqueue<CMessage> *pQ; };

static int numClients;
void _cdecl socketServer(void *clientSocket);

#endif	